package hr.fer.tel.ruazosa.databaseexample;

import android.app.Activity;
import android.os.AsyncTask;
import android.os.Bundle;
import android.view.View;
import android.widget.Button;
import android.widget.EditText;
import android.widget.TextView;
import android.widget.Toast;

import java.util.List;

public class OperateItemDatabaseActivity extends Activity {

    private ItemDatabase itemDatabase;

    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_operate_item_database);

        //open database and show toast
        itemDatabase = new ItemDatabase(OperateItemDatabaseActivity.this);

        CharSequence text = "Database Opened";
        int duration = Toast.LENGTH_SHORT;
        Toast toast = Toast.makeText(OperateItemDatabaseActivity.this, text,
                duration);
        toast.show();

        //asynchronous database opening
        //String input = "Some input";
        //new OpenItemDatabaseAsyncTask().execute(input);

        Button buttonAddItem = (Button) findViewById(R.id.button_add_item);
        buttonAddItem.setOnClickListener(new View.OnClickListener() {
            public void onClick(View v) {
                //get fields
                EditText editTextName = (EditText) findViewById(R.id.edittext_item_name);
                EditText editTextValue = (EditText) findViewById(R.id.edittext_item_value);
                EditText editTextAccessible = (EditText) findViewById(R.id.edittext_item_accessible);

                //parse fields
                String itemName = editTextName.getText().toString();
                float itemValue = Float.parseFloat(editTextValue.getText()
                        .toString());
                int itemAccessible = Integer.parseInt(editTextAccessible
                        .getText().toString());

                //clear fields
                editTextName.setText("");
                editTextValue.setText("");
                editTextAccessible.setText("");

                //create a new item, add it to the database and show toast
                Item item = new Item(itemName, itemValue, itemAccessible);
                OperateItemDatabaseActivity.this.itemDatabase.addItem(item);

                CharSequence text = "New Item Added";
                int duration = Toast.LENGTH_SHORT;
                Toast toast = Toast.makeText(OperateItemDatabaseActivity.this,
                        text, duration);
                toast.show();
            }
        });

        Button buttonClearItems = (Button) findViewById(R.id.button_clear_items);
        buttonClearItems.setOnClickListener(new View.OnClickListener() {
            public void onClick(View v) {
                //clear items and show toast
                itemDatabase.clearItems();

                CharSequence text = "All Items Cleared";
                int duration = Toast.LENGTH_SHORT;
                Toast toast = Toast.makeText(OperateItemDatabaseActivity.this,
                        text, duration);
                toast.show();
            }
        });

        Button buttonListItems = (Button) findViewById(R.id.button_list_items);
        buttonListItems.setOnClickListener(new View.OnClickListener() {
            public void onClick(View v) {
                //get all items
                List<Item> items = itemDatabase.getAllItems();
                StringBuilder sb = new StringBuilder();
                for (Item item : items) {
                    sb.append(item.getName());
                    sb.append(" ");
                    sb.append(item.getValue());
                    sb.append(" ");
                    sb.append(item.getAccessible());
                    sb.append("\n");
                }

                ((TextView) findViewById(R.id.textview_list_items)).setText(sb
                        .toString());
            }
        });

        //add some data to database
        //itemDatabase.addItem(new Item("prvi", 1.0f, 1));
        //itemDatabase.addItem(new Item("drugi", 2.0f, 0));
        //itemDatabase.addItem(new Item("treci", 3.0f, 1));
        //itemDatabase.addItem(new Item("cetvrti", 4.0f, 0));

        //read an item from database
        //Item item = itemDatabase.getItem(1);
    }

//    private class OpenItemDatabaseAsyncTask extends AsyncTask<String, Integer, String> {
//        @Override
//        protected String doInBackground(String... parameter) {
//            //moved to a background thread
//
//            //initialize myProgress
//            //int myProgress = 0;
//
//            //perform background processing task
//            //open the database
//            itemDatabase = new ItemDatabase(OperateItemDatabaseActivity.this);
//
//            //update myProgress
//            //publishProgress(myProgress);
//
//            //return the value to be passed to onPostExecute
//            return null;
//        }
//
//        @Override
//        protected void onProgressUpdate(Integer... progress) {
//            // synchronized to UI thread, update progress bar, notification, or
//            // other UI elements
//        }
//
//        @Override
//        protected void onPostExecute(String result) {
//            // synchronized to UI thread, report results via UI update, dialog,
//            // or notifications
//
//            // show toast
//            CharSequence text = "Database Opened";
//            int duration = Toast.LENGTH_SHORT;
//            Toast toast = Toast.makeText(OperateItemDatabaseActivity.this, text,
//                    duration);
//            toast.show();
//        }
//    }
}