package hr.fer.ruazosa.factcalc;

import android.os.AsyncTask;
import android.os.Bundle;
import android.app.Activity;
import android.view.View;
import android.widget.Button;
import android.widget.EditText;
import android.widget.ProgressBar;
import android.widget.TextView;

public class MainActivity extends Activity {

	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.activity_main);

		Button button = (Button) this.findViewById(R.id.button1);

		button.setOnClickListener(new View.OnClickListener() {

			@Override
			public void onClick(View v) {
				EditText number = (EditText) MainActivity.this.findViewById(R.id.editText1);
				new CalculateFactorialTask().execute(Short.parseShort(number.getText().toString()));
			}
		});
	}

	private class CalculateFactorialTask extends
			AsyncTask<Short, Integer, Long> {

		@Override
		protected void onPreExecute() {
			// disable clicking on button
			Button button = (Button) MainActivity.this
					.findViewById(R.id.button1);
			button.setClickable(false);

			//reset and show progress bar
			ProgressBar pbar = (ProgressBar) MainActivity.this
					.findViewById(R.id.progressBar1);
			pbar.setProgress(0);
			pbar.setVisibility(View.VISIBLE);
		}
		
		@Override
		protected Long doInBackground(Short... params) {
			short n = params[0];
			long result = 1L;

			for (short i = 1; i <= n; i++) {
				if (Long.MAX_VALUE / i < result) {
					//skip if overflow
					result = 0L;
					break;
				}
				result = result * i;
				
				//slow down the thread
				try {
					Thread.sleep(500);
				} catch (InterruptedException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
				
				//publish progress update
				publishProgress((int) Math.round((i*100)/n));
			}

			return result;
		}

		@Override
		protected void onProgressUpdate(Integer... values) {
			//update progress bar
			ProgressBar pbar = (ProgressBar) MainActivity.this
					.findViewById(R.id.progressBar1);
			pbar.setProgress(values[0]);
		}
		
		@Override
		protected void onPostExecute(Long result) {
			// show result
			EditText number = (EditText) MainActivity.this
					.findViewById(R.id.editText1);
			TextView resultText = (TextView) MainActivity.this
					.findViewById(R.id.textView1);
			resultText.setText("Result: "
					+ Integer.parseInt(number.getText().toString()) + "! = "
					+ String.valueOf(result));

			// enable clicking on button
			Button button = (Button) MainActivity.this
					.findViewById(R.id.button1);
			button.setClickable(true);
			
			//hide progress bar
			ProgressBar pbar = (ProgressBar) MainActivity.this
					.findViewById(R.id.progressBar1);
			pbar.setVisibility(View.INVISIBLE);
		}
	}
}
